﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IO_CHK
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        // INPUTチェック用 ---------------------------------------------------------------
        private ushort mInVal;                              // データ保持用変数
        private System.Windows.Forms.Label[]    lblINpToWin;  // チェック用コントロール配列
        // OUTPUTチェック用 --------------------------------------------------------------
        private ushort mOutVal;                             // データ保持用変数
        private System.Windows.Forms.CheckBox[] chkWinToINp; // チェック用コントロール配列


        //*****************************************************************************************
        // フォーム初期化
        //*****************************************************************************************
        private void Form1_Load(object sender, EventArgs e)
        {
            this.SuspendLayout();

            // INplc --> Windows用コントロールの作成(16点分)
            CreateINpToWinObj(16);
            // Windows --> INplc用コントロールの作成(16点分)
            CreateWinToINpObj(16);

            this.ResumeLayout(false);

        }
        //=========================================================================================
        //  INplc --> Windowsデータ表示用Labelコントロールを動的に作成
        //=========================================================================================
        private void CreateINpToWinObj(int n)
        {
            // 指定数分コントロールを設定
            this.lblINpToWin = new System.Windows.Forms.Label[n];
            for (int i = 0; i < lblINpToWin.Length; i++)
            {
                this.lblINpToWin[i] = new System.Windows.Forms.Label();
                this.lblINpToWin[i].BackColor = System.Drawing.Color.DarkGray;
                this.lblINpToWin[i].BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
                this.lblINpToWin[i].Cursor = System.Windows.Forms.Cursors.Arrow;
                this.lblINpToWin[i].Location = new System.Drawing.Point((7 - i % 8) * 40 + 10, (i / 8) * 24 + 24);
                this.lblINpToWin[i].Name = "lblQ_Area" + (i+1).ToString();
                this.lblINpToWin[i].Size = new System.Drawing.Size(34, 20);
                this.lblINpToWin[i].Text = i.ToString("d2");
                this.lblINpToWin[i].Tag = i;
                this.lblINpToWin[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            }

            // INplc --> Windows領域にコントロールを描画
            this.grpINpToWin.Controls.AddRange(this.lblINpToWin);

            // 共有メモリアクセスの設定
            inpINpToWin.GroupNo = 1;   // グループNo   ：1(共有メモリI/OドライバのOUTPUT設定で指定した値)
            inpINpToWin.Type = 1;      // データ型     ：符号なし2byte
            inpINpToWin.Mode = 3;      // モード       ：Qエリアのデータを読み込む

            // データ取得の設定
            timer1.Interval = 100;  // データ取得周期
            timer1.Enabled = true;  // データ取得開始

            // データを初期化
            mInVal = 0;
            inpINpToWin.Value = mInVal;
        }

        //=========================================================================================
        //  Windows --> INplc用データ設定CheckBoxコントロールを動的に作成
        //=========================================================================================
        private void CreateWinToINpObj(int n)
        {
            // 指定数分コントロールを設定
            this.chkWinToINp = new System.Windows.Forms.CheckBox[n];
            for (int i = 0; i < chkWinToINp.Length; i++)
            {
                this.chkWinToINp[i] = new System.Windows.Forms.CheckBox();
                this.chkWinToINp[i].Appearance = System.Windows.Forms.Appearance.Button;
                this.chkWinToINp[i].FlatStyle = System.Windows.Forms.FlatStyle.Standard;
                this.chkWinToINp[i].BackColor = System.Drawing.Color.WhiteSmoke;
                this.chkWinToINp[i].Cursor = System.Windows.Forms.Cursors.Hand;
                this.chkWinToINp[i].Location = new System.Drawing.Point((7 - i % 8) * 40 + 10, (i / 8) * 24 + 24);
                this.chkWinToINp[i].Name = "chkI_Area" + (i + 1).ToString();
                this.chkWinToINp[i].Size = new System.Drawing.Size(35, 22);
                this.chkWinToINp[i].Text = i.ToString("d2");
                this.chkWinToINp[i].Tag = i;
                this.chkWinToINp[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                this.chkWinToINp[i].UseVisualStyleBackColor = false;
                this.chkWinToINp[i].Click += new EventHandler(this.chkOutData_Click);

            }
            // Windows --> INplc領域にコントロールを描画
            this.grpWinToINp.Controls.AddRange(this.chkWinToINp);

            // 共有メモリアクセスの設定
            inpWinToINp.GroupNo = 1;  // グループNo   ：1(共有メモリI/OドライバのINPUT設定で指定した値)
            inpWinToINp.Type = 1;     // データ型     ：符号なし2byte
            inpWinToINp.Mode = 4;     // モード       ：Iエリアへデータを書き込む

            // データを初期化
            mOutVal = 0;
            inpWinToINp.Value = mOutVal;

        }



        private int iInputState;
        //*****************************************************************************************
        // INplcからデータ取得
        //*****************************************************************************************
        private void timer1_Tick(object sender, EventArgs e)
        {
            //-----------------------------------
            // INplcからデータを取得
            //-----------------------------------
            iInputState = inpINpToWin.Status;
            mInVal = (ushort)inpINpToWin.Value;
            // 画面にデータを設定
            for (int i = 0; i < lblINpToWin.Length; i++)
            {
                if ((mInVal & (1 << i)) != 0)
                {   // 該当ビットがONの場合、緑色で表示
                    lblINpToWin[i].BackColor = System.Drawing.Color.SpringGreen;
                }
                else
                {   // 該当ビットがOFFの場合、灰色で表示
                    lblINpToWin[i].BackColor = System.Drawing.Color.DarkGray;
                }

            }
        }
        //*****************************************************************************************
        // データ取得時のエラー
        //*****************************************************************************************
        private void inpINpToWin_OnError(object sender, AxINpMacLib._DINpMacEvents_OnErrorEvent e)
        {
            // 同じエラーが連続して発生している場合、メッセージは表示しない。
            if (iInputState == e.errCode)
                return; 
            
             ShowMsgBox(e.errCode, "!!! DATA GET ERROR !!!", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
        


        private int iOutputState;
        //***********************************************************************
        // INplcへデータ設定
        //***********************************************************************
        private void chkOutData_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.CheckBox objOutData = (System.Windows.Forms.CheckBox)sender;

            // 画面からデータを取得
            if (objOutData.Checked)
            {   // CheckBoxがONの場合、該当ビットをONに設定
                mOutVal += (ushort)(1 << ((int)objOutData.Tag));
                objOutData.BackColor = System.Drawing.Color.Tomato;     //ON時は背景を赤色で強調
            }
            else
            {   // CheckBoxがOFFの場合、該当ビットをOFFに設定
                mOutVal -= (ushort)(1 << ((int)objOutData.Tag));
                objOutData.BackColor = System.Drawing.Color.WhiteSmoke;
            }

            //-----------------------------------
            // INplcへデータを設定
            //-----------------------------------
            iOutputState = inpWinToINp.Status;
            if (iOutputState == 0) grpWinToINp.BackColor = System.Drawing.Color.Empty;
            inpWinToINp.Value = mOutVal;
        }
        //*****************************************************************************************
        // データ設定時のエラー
        //*****************************************************************************************
        private void inpWinToINp_OnError(object sender, AxINpMacLib._DINpMacEvents_OnErrorEvent e)
        {
            //// 同じエラーが連続して発生している場合、メッセージは表示しない。
            //if (iOutputState == e.errCode)
            //    return;   
            ShowMsgBox( e.errCode, "!!! DATA SET ERROR !!!", MessageBoxButtons.OK, MessageBoxIcon.Error);

        }



        //*****************************************************************************************
        // エラーメッセージ表示
        //*****************************************************************************************
        private DialogResult ShowMsgBox(int iErrCode, string strCaption, MessageBoxButtons iMsgBoxBtn, MessageBoxIcon iMsgBoxIcon)
        {
            DialogResult iRet;

            timer1.Stop();      // データの取得停止
            iRet = MessageBox.Show("ERR_CODE: 0x" + iErrCode.ToString("X8"), strCaption, iMsgBoxBtn, iMsgBoxIcon);
            timer1.Start();     // データの取得再開

            return iRet;
        }


    }
}
